/*_____________________________________________________________________________________________________________________________________________________________________
SNS_TABLE_OBJECT.mqh SNS_ObjectLibrary.mqhSteven N. Scott

NOTE: THIS IS AN #INCLUDE FILE AND (DUE TO A QUIRK IN MQL4) NEEDS TO BE IN BOTH YOUR EXPERT\LIBRARIES AND YOUR EXPERT\INDICATORS FOLDERS.
_______________________________________________________________________________________________________________________________________________________________________*/
#property copyright "Steven N. Scott"
#property link      ""

// IMPORT LIBRARY OF SNSCOTT'S COMMON FUNCTIONS AND UTILITIES============================================================================================================
// v2.0

#import "SNS_ObjectLibrary.ex4"

	// GENRERAL UTILITIES-------------------------------------------------------------------------------------------------------------------------------------------------
	string	SNSLibrary_Version();
	void 		SNSTAG();
	void 		DeleteObjectsByPrefix(string Prefix);
	bool   	IsMini();
	bool   	IsDoubleDotted();
	bool   	IsDotted();	

	// GRAPHIC OBJECT UTILITIES-------------------------------------------------------------------------------------------------------------------------------------------
   void 		Draw_HLine(string prefix, string name, int style, int width, color clr, datetime x, double y, bool back, int window=0);
   void 		Draw_VLine(string prefix, string name, int style, int width, color clr, datetime x,  bool back, int window=0);
   void 		Draw_TLine(string prefix, string name, int style, int width, color clr, datetime x1, double y1, datetime x2, double y2, bool ray, bool back, int window=0);
	void 		Draw_LabeledLine(string prefix, string name, int style, int width, color clr, datetime x1, double y1, datetime x2, double y2, bool ray, string label, string font, int fontsize, color fontcolor,datetime labelx, double labely, int window=0);
	void 		Draw_Box(string prefix, string name, color boxcolor, datetime x1, double y1, datetime x2, double y2, bool back, int linewidth, int linestyle, int window=0);
   void 		Draw_Fibo(string prefix, string name, int style, int width, color fibcolor, int levelstyle, int levelwidth, color levelcolor,  datetime x1, double y1, datetime x2, double y2, bool ray, bool back, int window=0);
	void 		Draw_FiboChannel(string prefix, string name, int style, int width, color fibcolor, int levelstyle, int levelwidth, color levelcolor,  datetime x1, double y1, datetime x2, double y2, datetime x3, double y3, bool ray, bool back, int window=0);
   void 		Draw_Text(string prefix, string name, string text, datetime x, double y, string font, int fontsize, color fontcolor, bool back, int window=0);
   void 		Draw_VText(string prefix, string name, string text, datetime x, double y, string font, int fontsize, color fontcolor, bool back, int window=0);
   void 		Draw_Label(string prefix, string name, string text, int corner, int x, int y, string font, int fontsize, color fontcolor, bool back, int window=0);
   void 		Draw_Symbol(string prefix, string name, int code, color colour, datetime x, double y, int size, bool back, int window=0);
   void 		Draw_Arrow(string prefix, string name, string dir, color colour, datetime x, double y, int size, bool back, int window=0);
   void 		Draw_PriceBox(string prefix, string name, bool left, int width, color colour, datetime x, double y, bool back, int window=0);
   
   // TIME UTILITIES----------------------------------------------------------------------------------------------------------------------------------------------------
	datetime Time_AddPeriod(datetime dt, int period, int inc);
	datetime Time_AddMinutes(datetime dt, int minutes);
	datetime Time_AddHours(datetime dt, int hours);
	datetime Time_AddDays(datetime dt, int days);
	datetime Time_Add(datetime dt, int inc);

	string 	Time_MDYHMSToStr(int nYear,int nMonth,int nDay,int nHour,int nMin,int nSec);
	string 	Time_DateTimeToStr(datetime dt); 
	string	Time_ToFormatStr(datetime dt, string format);	
	string 	Time_TFToString(int tf);
	string 	Time_FrameUnit(int tf);
	int 		Time_Encompassing(string tf);
	string	Time_DOW(int d);
	
	// STRING UTILITIES-------------------------------------------------------------------------------------------------------------------------------------------------
	int 		String_ToTimeFrame(string tf);
	string 	String_Repeat(string str, int n);
	string 	String_UpperCase(string str);
	string 	String_LowerCase(string str);
	string 	String_LeftPad(string str, int n, string str2);
	string 	String_RightPad(string str, int n, string str2);
	string 	String_Left(string str, int n);
	string 	String_Right(string str, int n);
	int 		String_ToArray(string& array[], string source);
	int 		String_ToUCArray(string& array[], string source);
	int 		String_ToLCArray(string& array[], string source);
	int 		String_ToIntArray(int& array[],string source);
	int 		String_ToDoubleArray(double& array[],string source);
	string 	String_Trim(string str);		
	string 	String_RightAlign( string rString, int ra );
	int 		String_ToColor(string str);
	string 	Price_AbrvToName(string p);
	string 	Price_Abrv(string p);
	
	// OBJECT UTILITIES-----------------------------------------------------------------------------------------------------------------------------------------------
	string 	Object_UniqueName(string prefix, string rest);

	// REVERSAL UTILITIES-----------------------------------------------------------------------------------------------------------------------------------------------
	color		Rev_GetColor(color defaultColor, bool SetIfMissing);
	color		Rev_SetColor(color RevColor);
	bool 		Rev_ColorChanged(color PreviousColor);
	int 		Rev_Status(string myPair, int TimeFrame, double Threshold, bool ShortTrader, bool LongTrader );
	
#import
///\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\

